(*This is a part of the TMultiButtonStyleManager*)

{%MultiButtonStyleManager ,this is a part of MultiButtonStyleManager}



{ TMultiButtonStyleManagerComponent }

constructor TStyleManagerComponent.Create(AComponent: TComponent;
  ADesigner: TComponentEditorDesigner);
begin
  inherited Create(AComponent, ADesigner);
  StyleComp := aComponent;
  Des := ADesigner;

end;

procedure TStyleManagerComponent.Edit;
begin
 DoShowEditor;
end;

function TStyleManagerComponent.GetVerbCount: Integer;
begin
  Result:= 1;
end;

function TStyleManagerComponent.GetVerb(Index: Integer): string;
begin
  Result := 'MultiButtonStyleManagerEditor';
end;

procedure TStyleManagerComponent.ExecuteVerb(Index: Integer);
begin
  DoShowEditor;
end;


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


procedure TStyleManagerComponent.DoShowEditor;
begin
 try
   Editor                := TForm.Create(Application);
   Editor.Width          := 800;
   Editor.Height         := 600;
   Editor.Left           := (screen.Width div 2) - (Editor.Width div 2);
   Editor.Top            := (screen.Height div 2) -(Editor.Height div 2);
   Editor.BorderStyle    := bsSingle;
   Editor.Caption        := 'MultiButtonStyleManagerEditor';

   DesignButton             := TMultiButton.Create(Editor);
   AssignProperties;
   DesignButton.Parent      := Editor;
   DesignButton.Tag         := 100;
   DesignButton.Name        := 'DesignButton';
   DesignButton.Left        := 10;
   DesignButton.Top         := 10;

   GeneralSettings;

   Settings              := TPageControl.Create(Editor);
   Settings.Parent       := Editor;
   Settings.Color        := clWindow;
   Settings.SetBounds(10,300,Editor.width-20,Editor.height-310);

   LookSettings;

   MSGLookSettings;

   ColorSettings;

   VariousSettings;

   FontSettings;

   Editor.ShowModal;
 finally
   Editor.Free;
 end;
end;



procedure TStyleManagerComponent.AssignProperties;
begin

  OffSetWidth    := (StyleComp as TMultiButtonStyleManager).OffSetWidth;
  OffSetHeight   := (StyleComp as TMultiButtonStyleManager).OffSetHeight;

  DesignButton.Style             := MultiButton.TMButtonStyle((StyleComp as TMultiButtonStyleManager).Style);
  DesignButton.Width             := (StyleComp as TMultiButtonStyleManager).Width;
  DesignButton.Height            := (StyleComp as TMultiButtonStyleManager).Height;
  DesignButton.RndRctRadius      := (StyleComp as TMultiButtonStyleManager).RndRctRadius;
  DesignButton.FocusedOn         := (StyleComp as TMultiButtonStyleManager).FocusedOn;
  DesignButton.FocusFrameWidth   := (StyleComp as TMultiButtonStyleManager).FocusFrameWidth;
  DesignButton.FocusAlphaBValue  := (StyleComp as TMultiButtonStyleManager).FocusAlphaBValue;
  DesignButton.ShowBorder        := (StyleComp as TMultiButtonStyleManager).ShowBorder;
  DesignButton.HoverOn           := (StyleComp as TMultiButtonStyleManager).HoverOn;
  DesignButton.BorderWidth       := (StyleComp as TMultiButtonStyleManager).BorderWidth;
  DesignButton.ColorGradient     := MultiButton.TGradientCourse((StyleComp as TMultiButtonStyleManager).ColorGradient);

  DesignButton.MessageButton.Visible  := (StyleComp as TMultiButtonStyleManager).MessageButtonVisible;
  DesignButton.MessageButton.Style    := MultiButton.TMButtonStyle((StyleComp as TMultiButtonStyleManager).MessageButtonStyle);
  DesignButton.MessageButton.Width    := (StyleComp as TMultiButtonStyleManager).MessageButtonWidth;
  DesignButton.MessageButton.Height   := (StyleComp as TMultiButtonStyleManager).MessageButtonHeight;
  DesignButton.MessageButton.Alignment:= MultiButton.TMBAlignment((StyleComp as TMultiButtonStyleManager).MessageButtonAlignment);
  DesignButton.MessageButton.PositionFactor:= (StyleComp as TMultiButtonStyleManager).MessageButtonPositionFactor;
  DesignButton.MessageButton.CalculateAlthoughInvisible := (StyleComp as TMultiButtonStyleManager).MessageButtonCalculateAlthoughInvisible;
  DesignButton.MessageButton.HoverOn  := (StyleComp as TMultiButtonStyleManager).MessageButtonHoverOn;
  DesignButton.MessageButton.ShowPressed:= (StyleComp as TMultiButtonStyleManager).MessageButtonShowPressed;
  DesignButton.MessageButton.ShowBorder:= (StyleComp as TMultiButtonStyleManager).MessageButtonShowBorder;
  DesignButton.MessageButton.PresdColBlendVal:= (StyleComp as TMultiButtonStyleManager).MessageButtonPresdColBlendVal;
  DesignButton.MessageButton.BorderWidth := (StyleComp as TMultiButtonStyleManager).MessageButtonBorderWidth;
  DesignButton.MessageButton.ColorGradient:= MultiButton.TGradientCourse((StyleComp as TMultiButtonStyleManager).MessageButtonColorGradient);

  DesignButton.ColorStart        := (StyleComp as TMultiButtonStyleManager).ColorStart;
  DesignButton.ColorEnd          := (StyleComp as TMultiButtonStyleManager).ColorEnd;
  DesignButton.BorderColor       := (StyleComp as TMultiButtonStyleManager).BorderColor;
  DesignButton.HoverStartColor   := (StyleComp as TMultiButtonStyleManager).HoverStartColor;
  DesignButton.HoverEndColor     := (StyleComp as TMultiButtonStyleManager).HoverEndColor;
  DesignButton.HoverFontColor    := (StyleComp as TMultiButtonStyleManager).HoverFontColor;
  DesignButton.Font.Assign((StyleComp as TMultiButtonStyleManager).Font);
  DesignButton.FocusColor        := (StyleComp as TMultiButtonStyleManager).FocusColor;
  DesignButton.PressedStartColor := (StyleComp as TMultiButtonStyleManager).PressedStartColor;
  DesignButton.PressedEndColor   := (StyleComp as TMultiButtonStyleManager).PressedEndColor;
  DesignButton.PressedFontColor  := (StyleComp as TMultiButtonStyleManager).PressedFontColor;
  DesignButton.MessageButton.ColorStart        := (StyleComp as TMultiButtonStyleManager).MessageButtonColorStart;
  DesignButton.MessageButton.ColorEnd          := (StyleComp as TMultiButtonStyleManager).MessageButtonColorEnd;
  DesignButton.MessageButton.BorderColor       := (StyleComp as TMultiButtonStyleManager).MessageButtonBorderColor;
  DesignButton.MessageButton.Font              := (StyleComp as TMultiButtonStyleManager).MessageButtonFont;
  DesignButton.MessageButton.HoverColor        := (StyleComp as TMultiButtonStyleManager).MessageButtonHoverColor;
  DesignButton.MessageButton.PressedColor      := (StyleComp as TMultiButtonStyleManager).MessageButtonPressedColor;

  DesignButton.AllowsUp             := (StyleComp as TMultiButtonStyleManager).AllowsUp;
  DesignButton.Down                 := (StyleComp as TMultiButtonStyleManager).Down;
  DesignButton.ShowMsgButtonInGroup := (StyleComp as TMultiButtonStyleManager).ShowMsgButtonInGroup;
  DesignButton.GroupIndex           := (StyleComp as TMultiButtonStyleManager).GroupIndex;

  DesignButton.CaptionAlignment     := (StyleComp as TMultiButtonStyleManager).CaptionAlignment;
  DesignButton.CaptionLayout        := (StyleComp as TMultiButtonStyleManager).CaptionLayout;
  DesignButton.CaptionHorMargin     := (StyleComp as TMultiButtonStyleManager).CaptionHorMargin;
  DesignButton.CaptionVerMargin     := (StyleComp as TMultiButtonStyleManager).CaptionVerMargin;
  DesignButton.CaptionWordbreak     := (StyleComp as TMultiButtonStyleManager).CaptionWordbreak;

  DesignButton.MessageButton.CaptionAlignment     := (StyleComp as TMultiButtonStyleManager).MessageButtonCaptionAlignment;
  DesignButton.MessageButton.CaptionLayout        := (StyleComp as TMultiButtonStyleManager).MessageButtonCaptionLayout;
  DesignButton.MessageButton.CaptionHorMargin     := (StyleComp as TMultiButtonStyleManager).MessageButtonCaptionHorMargin;
  DesignButton.MessageButton.CaptionVerMargin     := (StyleComp as TMultiButtonStyleManager).MessageButtonCaptionVerMargin;

  end;

procedure TStyleManagerComponent.GeneralSettings;
var Panel            : TPanel;
    OkButton         : TMultiButton;
    AbortButton      : TMultiButton;
    EditLeft         : TLabeledEdit;
    EditTop          : TLabeledEdit;
    CheckOffSetWidth : TCheckBox;
    CheckOffSetHeight: TCheckBox;
begin
   Panel                    := TPanel.Create(Editor);
   Panel.Parent             := Editor;
   Panel.Color              := clWindow;
   Panel.SetBounds(600,20,190,280);

   EditLeft                   := TLabeledEdit.Create(Panel);
   EditLeft.Parent            := Panel;
   EditLeft.SetBounds(10,30,70,28);
   EditLeft.EditLabel.Caption := 'Left:';
   EditLeft.Caption           := inttostr(DesignButton.Left);
   EditLeft.Alignment         := taRightJustify;
   EditLeft.Tag               := 0;
   EditLeft.OnChange          := @SetLeftTop;

   EditTop                   := TLabeledEdit.Create(Panel);
   EditTop.Parent            := Panel;
   EditTop.SetBounds(110,30,70,28);
   EditTop.EditLabel.Caption := 'Top:';
   EditTop.Caption           := inttostr(DesignButton.Top);
   EditTop.Alignment         := taRightJustify;
   EditTop.Tag               := 1;
   EditTop.OnChange          := @SetLeftTop;

   CheckOffSetWidth          := TCheckBox.Create(Panel);
   CheckOffSetWidth.Parent   := Panel;
   CheckOffSetWidth.SetBounds(10,70,300,20);
   CheckOffSetWidth.Checked  := OffSetWidth;
   CheckOffSetWidth.Caption  := 'Take over the width';
   CheckOffSetWidth.Tag      := 0;
   CheckOffSetWidth.OnChange := @OffSet;

   CheckOffSetHeight          := TCheckBox.Create(Panel);
   CheckOffSetHeight.Parent   := Panel;
   CheckOffSetHeight.SetBounds(10,90,300,20);
   CheckOffSetHeight.Checked  := OffSetHeight;
   CheckOffSetHeight.Caption  := 'Take over the height';
   CheckOffSetHeight.Tag      := 1;
   CheckOffSetHeight.OnChange := @OffSet;


   OkButton                 := TMultiButton.Create(Editor);
   OkButton.Parent          := Panel;
   OkButton.Tag             := 101;
   OkButton.Name            := 'Okay';
   OkButton.FocusFrameWidth := 2;
   OkButton.Style           := MultiButton.TMButtonStyle(mbsRect);
   OkButton.Height          := 25;
   OkButton.Width           := 170;
   OkButton.Left            := 10;
   OkButton.Top             := 245;
   OkButton.OnClick         := @OK_AbortButtonOnClick;

   AbortButton                 := TMultiButton.Create(Editor);
   AbortButton.Parent          := Panel;
   AbortButton.Tag             := 102;
   AbortButton.Name            := 'Abort';
   AbortButton.FocusFrameWidth := 2;
   AbortButton.Style           := MultiButton.TMButtonStyle(mbsRect);
   AbortButton.Height          := 25;
   AbortButton.Width           := 170;
   AbortButton.Left            := 10;
   AbortButton.Top             := 210;
   AbortButton.OnClick         := @OK_AbortButtonOnClick;
end;

procedure TStyleManagerComponent.LookSettings;
var lv            : integer;
    StaticText1   : TStaticText;
    StaticText2   : TStaticText;
begin
 Look                := TTabsheet.Create(Editor);
 Look.Parent         := Settings;
 Look.Caption        := 'Look';

 StaticText1         := TStaticText.Create(Look);
 StaticText1.Parent  := look;
 StaticText1.SetBounds(10,120,150,25);
 StaticText1.Caption := 'Style:';

 StyleCombobox        := TComboBox.Create(Look);
 StyleCombobox.Parent := Look;
 StyleCombobox.SetBounds(10,140,150,28);
 StyleCombobox.Items.Add('mbsRect');
 StyleCombobox.Items.Add('mbsRoundRect');
 StyleCombobox.Items.Add('mbsCircle');
 StyleCombobox.Items.Add('mbsEllipse');
 StyleCombobox.ItemIndex:= ord(DesignButton.Style);
 StyleCombobox.OnChange:= @StyleOnChange;

 StaticText2         := TStaticText.Create(Look);
 StaticText2.Parent  := look;
 StaticText2.SetBounds(10,65,150,25);
 StaticText2.Caption := 'ColorGradient:';

 ColGradCombo        := TComboBox.Create(Look);
 ColGradCombo.Parent := Look;
 ColGradCombo.SetBounds(10,85,150,28);
 ColGradCombo.Items.Add('gcHorizontal');
 ColGradCombo.Items.Add('gcVertical');
 ColGradCombo.Items.Add('gcSpread');
 ColGradCombo.Items.Add('gcRadiant');
 ColGradCombo.ItemIndex:= ord(DesignButton.ColorGradient);
 ColGradCombo.OnChange:= @ColGradOnChange;

 for lv:=0 to 5 do
  begin
   lEdits[lv]         := TLabeledEdit.Create(Look);
   lEdits[lv].Parent  := Look;
   lEdits[lv].Width   :=  70;
   lEdits[lv].Height  :=  28;
   lEdits[lv].Tag     := lv;
   lEdits[lv].Alignment:= taRightJustify;
   lEdits[lv].OnChange:= @lEditsOnChange;
  end;
 lEdits[0].EditLabel.Caption := 'Width:';
 lEdits[0].Left    := 10;
 lEdits[0].Top     := 32;
 lEdits[0].Caption := inttostr(DesignButton.Width);
 if OffSetWidth then
  lEdits[0].Font.Color:= clDefault else lEdits[0].Font.Color:= clRed;

 lEdits[1].EditLabel.Caption := 'Height:';
 lEdits[1].Left    := 90;
 lEdits[1].Top     := 32; //85
 lEdits[1].Caption := inttostr(DesignButton.Height);
 if OffSetHeight then
  lEdits[1].Font.Color:= clDefault else lEdits[1].Font.Color:= clRed;
 if DesignButton.Style = MultiButton.TMButtonStyle(mbsCircle) then lEdits[1].Enabled:=false;

 lEdits[2].EditLabel.Caption := 'RndRctRadius:';
 lEdits[2].Left    := 10;
 lEdits[2].Top     := 200;//140;
 lEdits[2].Width   := 150;
 lEdits[2].Caption := inttostr(DesignButton.RndRctRadius);
 if DesignButton.Style <> MultiButton.TMButtonStyle(mbsRoundRect) then lEdits[2].Enabled:= false else lEdits[2].Enabled:= true;

 lEdits[3].EditLabel.Caption := 'Foc.FrameWidth:';
 lEdits[3].Left    := 210;
 lEdits[3].Top     := 85;
 lEdits[3].Width   := 100;
 lEdits[3].Caption := inttostr(DesignButton.FocusFrameWidth);

 lEdits[4].EditLabel.Caption := 'Foc.AlphaBVal.:';
 lEdits[4].Left    := 210;
 lEdits[4].Top     := 140;
 lEdits[4].Width   := 100;
 lEdits[4].Caption := inttostr(DesignButton.FocusAlphaBValue);

 lEdits[5].EditLabel.Caption := 'BorderWidth:';
 lEdits[5].Left    := 350;
 lEdits[5].Top     :=  85;
 lEdits[5].Width   := 100;
 lEdits[5].Caption := inttostr(DesignButton.BorderWidth);

 for lv:=0 to 2 do
  begin
   lCheckBox[lv]         := TCheckBox.Create(Look);
   lCheckBox[lv].Parent  := Look;
   lCheckBox[lv].Width   := 100;
   lCheckBox[lv].Height  :=  28;
   lCheckBox[lv].Tag     := lv;
   lCheckBox[lv].OnClick := @LCheckBoxOnClick;
  end;

   lCheckBox[0].Caption := 'FocusedOn';
   lCheckBox[0].Checked := DesignButton.FocusedOn;
   lCheckBox[0].Left    := 210;
   lCheckBox[0].Top     := 28;

   lCheckBox[1].Caption := 'ShowBorder';
   lCheckBox[1].Checked := DesignButton.ShowBorder;
   lCheckBox[1].Left    := 350;
   lCheckBox[1].Top     := 28;

   lCheckBox[2].Caption := 'HoverOn';
   lCheckBox[2].Checked := DesignButton.HoverOn;
   lCheckBox[2].Left    := 490;
   lCheckBox[2].Top     := 28;


end;

procedure TStyleManagerComponent.LCheckBoxOnClick(Sender: TObject);
begin
  case (Sender as TCheckBox).Tag of
   0: DesignButton.FocusedOn        := (Sender as TCheckBox).Checked;
   1: DesignButton.ShowBorder       := (Sender as TCheckBox).Checked;
   2: DesignButton.HoverOn          := (Sender as TCheckBox).Checked;
  end;

end;

procedure TStyleManagerComponent.StyleOnChange(Sender: TObject);
begin
 case (Sender as TComboBox).ItemIndex of
  0 : DesignButton.Style := MultiButton.TMButtonStyle(mbsRect);
  1 : DesignButton.Style := MultiButton.TMButtonStyle(mbsRoundRect);
  2 : DesignButton.Style := MultiButton.TMButtonStyle(mbsCircle);
  3 : DesignButton.Style := MultiButton.TMButtonStyle(mbsEllipse);
 end;
 if DesignButton.Style = MultiButton.TMButtonStyle(mbsCircle) then lEdits[1].Caption := inttostr(DesignButton.Width);
 if DesignButton.Style <> MultiButton.TMButtonStyle(mbsRoundRect) then lEdits[2].Enabled:= false else lEdits[2].Enabled:= true;
 if DesignButton.Style = MultiButton.TMButtonStyle(mbsCircle) then lEdits[1].Enabled:=false else lEdits[1].Enabled:=true;
end;

procedure TStyleManagerComponent.ColGradOnChange(Sender: TObject);
begin
 case (Sender as TComboBox).ItemIndex of
  0 : DesignButton.ColorGradient := MultiButton.TGradientCourse(gcHorizontal);
  1 : DesignButton.ColorGradient := MultiButton.TGradientCourse(gcVertical);
  2 : DesignButton.ColorGradient := MultiButton.TGradientCourse(gcSpread);
  3 : DesignButton.ColorGradient := MultiButton.TGradientCourse(gcRadiant);
 end;
end;

procedure TStyleManagerComponent.lEditsOnChange(Sender: TObject);
var i,r : integer;
begin
 r := DesignButton.RndRctRadius;
 case (Sender as TLabeledEdit).Tag of
  0: begin
      DesignButton.Width           := strtointdef((Sender as TLabeledEdit).Caption,0);
      DesignButton.RndRctRadius    := r;
     end;
  1: DesignButton.Height           := strtointdef((Sender as TLabeledEdit).Caption,0);
  2: DesignButton.RndRctRadius     := strtointdef((Sender as TLabeledEdit).Caption,0);
  3: DesignButton.FocusFrameWidth  := strtointdef((Sender as TLabeledEdit).Caption,0);
  4: begin
      i:= strtointdef((Sender as TLabeledEdit).Caption,0);
      if (i<0) or (i>255) then
       begin
        showmessage('Value must between 0 and 255');
        lEdits[4].Caption := inttostr(255);
        exit;
       end;
      DesignButton.FocusAlphaBValue :=i;
     end;
  5: DesignButton.BorderWidth       := strtointdef((Sender as TLabeledEdit).Caption,0);
 end;
 if DesignButton.Style = MultiButton.TMButtonStyle(mbsCircle) then lEdits[1].Caption:=inttostr(DesignButton.Width);

end;

procedure TStyleManagerComponent.MSGLookSettings;
var lv           : integer;
    StaticText1  : TStaticText;
    StaticText2  : TStaticText;
    StaticText3  : TStaticText;
begin
 MsgButtonLook                := TTabsheet.Create(Editor);
 MsgButtonLook.Parent         := Settings;
 MsgButtonLook.Caption        := 'MsgButtonLook';

 for lv:=0 to 4 do
  begin
   MsgCheckBox[lv]         := TCheckBox.Create(MsgButtonLook);
   MsgCheckBox[lv].Parent  := MsgButtonLook;
   MsgCheckBox[lv].Width   := 100;
   MsgCheckBox[lv].Height  :=  28;
   MsgCheckBox[lv].Tag     := lv;
   MsgCheckBox[lv].OnClick := @MsgCheckBoxOnClick;
  end;

 MsgCheckBox[0].Caption := 'Visible';
 MsgCheckBox[0].Checked := DesignButton.MessageButton.Visible;
 MsgCheckBox[0].Left    := 10;
 MsgCheckBox[0].Top     := 10;

 StaticText1         := TStaticText.Create(MsgButtonLook);
 StaticText1.Parent  := MsgButtonlook;
 StaticText1.SetBounds(10,40,150,25);
 StaticText1.Caption := 'Style:';

 MsgStyleCombobox        := TComboBox.Create(MsgButtonLook);
 MsgStyleCombobox.Parent := MsgButtonLook;
 MsgStyleCombobox.SetBounds(10,60,150,28);
 MsgStyleCombobox.Items.Add('mbsRect');
 MsgStyleCombobox.Items.Add('mbsRoundRect');
 MsgStyleCombobox.Items.Add('mbsCircle');
 MsgStyleCombobox.Items.Add('mbsEllipse');
 MsgStyleCombobox.ItemIndex:= ord(DesignButton.Style);
 MsgStyleCombobox.OnChange:= @MsgStyleOnChange;

 for lv:=0 to 4 do
  begin
   MsgEdits[lv]         := TLabeledEdit.Create(MsgButtonLook);
   MsgEdits[lv].Parent  := MsgButtonLook;
   MsgEdits[lv].Width   :=  70;
   MsgEdits[lv].Height  :=  18;
   MsgEdits[lv].Tag     := lv;
   MsgEdits[lv].Alignment:= taRightJustify;
   MsgEdits[lv].OnChange:= @MsgEditsOnChange;
  end;
 MsgEdits[0].EditLabel.Caption := 'Width:';
 MsgEdits[0].Left    := 10;
 MsgEdits[0].Top     := 115;
 MsgEdits[0].Caption := inttostr(DesignButton.MessageButton.Width);

 MsgEdits[1].EditLabel.Caption := 'Height:';
 MsgEdits[1].Left    := 90;
 MsgEdits[1].Top     := 115;
 MsgEdits[1].Caption := inttostr(DesignButton.MessageButton.Height);
 if DesignButton.MessageButton.Style = MultiButton.TMButtonStyle(mbsCircle) then MsgEdits[1].Enabled:=false;

 StaticText2         := TStaticText.Create(MsgButtonLook);
 StaticText2.Parent  := MsgButtonlook;
 StaticText2.SetBounds(10,150,150,25);
 StaticText2.Caption := 'Alignment:';

 MsgAlignment        := TComboBox.Create(MsgButtonLook);
 MsgAlignment.Parent := MsgButtonLook;
 MsgAlignment.SetBounds(10,170,150,28);
 MsgAlignment.Items.Add('alNW');
 MsgAlignment.Items.Add('alN');
 MsgAlignment.Items.Add('alNE');
 MsgAlignment.Items.Add('alE');
 MsgAlignment.Items.Add('alSE');
 MsgAlignment.Items.Add('alS');
 MsgAlignment.Items.Add('alSW');
 MsgAlignment.Items.Add('alW');
 MsgAlignment.Items.Add('alRightIn');
 MsgAlignment.Items.Add('alLeftIn');
 MsgAlignment.Items.Add('alTopIn');
 MsgAlignment.Items.Add('alBottomIn');
 MsgAlignment.Items.Add('alRightOut');
 MsgAlignment.Items.Add('alLeftOut');
 MsgAlignment.Items.Add('alTopOut');
 MsgAlignment.Items.Add('alBottomOut');
 MsgAlignment.ItemIndex:= ord(DesignButton.MessageButton.Alignment);
 MsgAlignment.OnChange:= @MsgAlignmentOnChange;

 MsgEdits[2].EditLabel.Caption := 'PositionFactor:';
 MsgEdits[2].Left    := 10;
 MsgEdits[2].Top     := 225;
 MsgEdits[2].Width   := 150;
 MsgEdits[2].Caption := inttostr(DesignButton.MessageButton.PositionFactor);

 MsgCheckBox[1].Caption := 'CalculateAlthoughInvisible';
 MsgCheckBox[1].Checked := DesignButton.MessageButton.CalculateAlthoughInvisible;
 MsgCheckBox[1].Left    := 180;
 MsgCheckBox[1].Top     := 10;

 MsgCheckBox[2].Caption := 'HoverOn';
 MsgCheckBox[2].Checked := DesignButton.MessageButton.HoverOn;
 MsgCheckBox[2].Left    := 180;
 MsgCheckBox[2].Top     := 40;

 MsgCheckBox[3].Caption := 'ShowPressed';
 MsgCheckBox[3].Checked := DesignButton.MessageButton.ShowPressed;
 MsgCheckBox[3].Left    := 180;
 MsgCheckBox[3].Top     := 70;

 MsgEdits[3].EditLabel.Caption := 'PresdColBlendVal:';
 MsgEdits[3].Left    := 180;
 MsgEdits[3].Top     := 115;
 MsgEdits[3].Width   := 150;
 MsgEdits[3].Caption := inttostr(DesignButton.MessageButton.PresdColBlendVal);

 MsgCheckBox[4].Caption := 'ShowBorder';
 MsgCheckBox[4].Checked := DesignButton.MessageButton.ShowBorder;
 MsgCheckBox[4].Left    := 180;
 MsgCheckBox[4].Top     := 150;

 MsgEdits[4].EditLabel.Caption := 'BorderWidth:';
 MsgEdits[4].Left    := 180;
 MsgEdits[4].Top     := 195;
 MsgEdits[4].Width   := 150;
 MsgEdits[4].Caption := inttostr(DesignButton.MessageButton.BorderWidth);

 StaticText3         := TStaticText.Create(MsgButtonLook);
 StaticText3.Parent  := MsgButtonLook;
 StaticText3.SetBounds(400,10,150,25);
 StaticText3.Caption := 'ColorGradient:';

 MsgColGradCombo        := TComboBox.Create(MsgButtonLook);
 MsgColGradCombo.Parent := MsgButtonLook;
 MsgColGradCombo.SetBounds(400,30,150,28);
 MsgColGradCombo.Items.Add('gcHorizontal');
 MsgColGradCombo.Items.Add('gcVertical');
 MsgColGradCombo.Items.Add('gcSpread');
 MsgColGradCombo.Items.Add('gcRadiant');
 MsgColGradCombo.ItemIndex:= ord(DesignButton.ColorGradient);
 MsgColGradCombo.OnChange:= @MsgColGradOnChange;
end;

procedure TStyleManagerComponent.MsgCheckBoxOnClick(Sender: TObject);
begin
 case (Sender as TCheckBox).Tag of
   0: DesignButton.MessageButton.Visible                    := (Sender as TCheckBox).Checked;
   1: DesignButton.MessageButton.CalculateAlthoughInvisible := (Sender as TCheckBox).Checked;
   2: DesignButton.MessageButton.HoverOn                    := (Sender as TCheckBox).Checked;
   3: DesignButton.MessageButton.ShowPressed                := (Sender as TCheckBox).Checked;
   4: DesignButton.MessageButton.ShowBorder                 := (Sender as TCheckBox).Checked;
  end;
end;

procedure TStyleManagerComponent.MsgStyleOnChange(Sender: TObject);
begin
  case (Sender as TComboBox).ItemIndex of
  0 : DesignButton.MessageButton.Style := MultiButton.TMButtonStyle(mbsRect);
  1 : DesignButton.MessageButton.Style := MultiButton.TMButtonStyle(mbsRoundRect);
  2 : DesignButton.MessageButton.Style := MultiButton.TMButtonStyle(mbsCircle);
  3 : DesignButton.MessageButton.Style := MultiButton.TMButtonStyle(mbsEllipse);
 end;
 if DesignButton.MessageButton.Style = MultiButton.TMButtonStyle(mbsCircle) then MsgEdits[1].Caption := inttostr(DesignButton.MessageButton.Width);
 if DesignButton.MessageButton.Style = MultiButton.TMButtonStyle(mbsCircle) then MsgEdits[1].Enabled:=false else MsgEdits[1].Enabled:=true;
end;

procedure TStyleManagerComponent.MsgEditsOnChange(Sender: TObject);
var i : integer;
begin
 case (Sender as TLabeledEdit).Tag of
  0: DesignButton.MessageButton.Width            := strtointdef((Sender as TLabeledEdit).Caption,0);
  1: DesignButton.MessageButton.Height           := strtointdef((Sender as TLabeledEdit).Caption,0);
  2: DesignButton.MessageButton.PositionFactor   := strtointdef((Sender as TLabeledEdit).Caption,1);
  3: begin
      i:= strtointdef((Sender as TLabeledEdit).Caption,0);
      if (i<0) or (i>255) then
       begin
        showmessage('Value must between 0 and 255');
        MsgEdits[3].Caption := inttostr(255);
        exit;
       end;
      DesignButton.MessageButton.PresdColBlendVal :=i;
     end;
  4: DesignButton.MessageButton.BorderWidth   := strtointdef((Sender as TLabeledEdit).Caption,1);
 end;
 if DesignButton.MessageButton.Style = MultiButton.TMButtonStyle(mbsCircle) then MsgEdits[1].Caption:=inttostr(DesignButton.MessageButton.Width);
end;

procedure TStyleManagerComponent.MsgAlignmentOnChange(Sender: TObject);
begin
 case (Sender as TComboBox).ItemIndex of
  0 : DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alNW);
  1 : DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alN);
  2 : DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alNE);
  3 : DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alE);
  4 : DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alSE);
  5 : DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alS);
  6 : DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alSW);
  7 : DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alW);
  8 : DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alRightIn);
  9 : DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alLeftIn);
  10: DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alTopIn);
  11: DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alBottomIn);
  12: DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alRightOut);
  13: DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alLeftOut);
  14: DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alTopOut);
  15: DesignButton.MessageButton.Alignment := MultiButton.TMBAlignment(alBottomOut);

 end;
end;

procedure TStyleManagerComponent.MsgColGradOnChange(Sender: TObject);
begin
  case (Sender as TComboBox).ItemIndex of
  0 : DesignButton.MessageButton.ColorGradient := MultiButton.TGradientCourse(gcHorizontal);
  1 : DesignButton.MessageButton.ColorGradient := MultiButton.TGradientCourse(gcVertical);
  2 : DesignButton.MessageButton.ColorGradient := MultiButton.TGradientCourse(gcSpread);
  3 : DesignButton.MessageButton.ColorGradient := MultiButton.TGradientCourse(gcRadiant);
 end;
end;

procedure TStyleManagerComponent.AdjustColorBox(aColor: TColor; aIndex: integer);
var Str         : string;
    lv          : integer;
    clfl        : boolean;
begin
 str := colortostring(aColor); clfl := false;
 for lv:=0 to pred(AColorBox[aIndex].Items.Count) do
   begin
    if AColorBox[aIndex].Items.Strings[lv] = str then clfl :=true;
    if clfl then break;
   end;
 if not clfl then AColorBox[aIndex].Items.InsertObject(0,str,TObject(PtrInt(aColor)));
 AColorBox[aIndex].Selected:=aColor;
end;

procedure TStyleManagerComponent.ColorSettings;
var lv            : integer;
    StaticText1   : TStaticText;
    StaticText2   : TStaticText;
begin
 Colors                := TTabsheet.Create(Editor);
 Colors.Parent         := Settings;
 Colors.Caption        := 'Colors';

 StaticText1           := TStaticText.Create(Colors);
 StaticText1.Parent    := Colors;
 StaticText1.Caption   := 'MultiButton Settings:';
 StaticText1.SetBounds(10,5,300,25);

 StaticText2           := TStaticText.Create(Colors);
 StaticText2.Parent    := Colors;
 StaticText2.Caption   := 'MessageButton Settings:';
 StaticText2.SetBounds(520,5,300,25);

 for lv:=0 to 16 do
  begin
   ColorButtons[lv]         := TMultiButton.Create(Colors);
   ColorButtons[lv].Parent  := Colors;
   ColorButtons[lv].Width   := 100;
   ColorButtons[lv].Height  :=  28;
   ColorButtons[lv].FocusFrameWidth:= 2;
   ColorButtons[lv].Style   := MultiButton.TMButtonStyle(mbsRect);
   ColorButtons[lv].Tag     := lv;
   ColorButtons[lv].OnClick := @ColorButtonsOnClick;
   ColorButtons[lv].MessageButton.Style       := MultiButton.TMButtonStyle(mbsRect);
   ColorButtons[lv].MessageButton.Alignment   := MultiButton.TMBAlignment(alRightIn);
   ColorButtons[lv].MessageButton.Width       := 20;
   ColorButtons[lv].MessageButton.Height      := 20;

   AColorBox[lv]         := TColorBox.Create(Colors);
   AColorBox[lv].Parent  := Colors;
   AColorBox[lv].Tag     := lv;
   AColorBox[lv].Width   := 120;
   AColorBox[lv].Style   := [cbStandardColors,cbExtendedColors,cbSystemColors,cbCustomColors];
   AColorBox[lv].OnChange:= @ColorBoxOnChange;

   if lv<=5 then
    begin
     ColorButtons[lv].Left   := 10;
     AColorBox[lv].Left      := 112;
     ColorButtons[lv].Top     := 30+(lv*35);
     AColorBox[lv].Top        := 30+(lv*35);
    end;
   if (lv>5) and (lv<=10) then
    begin
     ColorButtons[lv].Left   := 250;
     AColorBox[lv].Left      := 352;
     ColorButtons[lv].Top     := 30+((lv-6)*35);
     AColorBox[lv].Top        := 30+((lv-6)*35);
    end;
   if lv>10 then
    begin
     ColorButtons[lv].Left   := 520;
     AColorBox[lv].Left      := 622;
     ColorButtons[lv].Top     := 30+((lv-11)*35);
     AColorBox[lv].Top        := 30+((lv-11)*35);
    end;
  end;

  ColorButtons[0].Caption := 'ColorStart';
  AdjustColorBox(DesignButton.ColorStart,0);
  ColorButtons[1].Caption := 'ColorEnd';
  AdjustColorBox(DesignButton.ColorEnd,1);
  ColorButtons[2].Caption := 'BorderColor';
  AdjustColorBox(DesignButton.BorderColor,2);
  ColorButtons[3].Caption := 'HoverStartCol';
  AdjustColorBox(DesignButton.HoverStartColor,3);
  ColorButtons[4].Caption := 'HoverEndColor';
  AdjustColorBox(DesignButton.HoverEndColor,4);
  ColorButtons[5].Caption := 'HoverFontCol';
  AdjustColorBox(DesignButton.HoverFontColor,5);
  ColorButtons[6].Caption := 'FontColor';
  AdjustColorBox(DesignButton.Font.Color,6);
  ColorButtons[7].Caption := 'FocusColor';
  AdjustColorBox(DesignButton.FocusColor,7);
  ColorButtons[8].Caption := 'PressedStCol';
  AdjustColorBox(DesignButton.PressedStartColor,8);
  ColorButtons[9].Caption := 'PressedEndCol';
  AdjustColorBox(DesignButton.PressedEndColor,9);
  ColorButtons[10].Caption := 'PrssdFontCol';
  AdjustColorBox(DesignButton.PressedFontColor,10);
  ColorButtons[11].Caption := 'ColorStart';
  AdjustColorBox(DesignButton.MessageButton.ColorStart,11);
  ColorButtons[12].Caption := 'ColorEnd';
  AdjustColorBox(DesignButton.MessageButton.ColorEnd,12);
  ColorButtons[13].Caption := 'BorderColor';
  AdjustColorBox(DesignButton.MessageButton.BorderColor,13);
  ColorButtons[14].Caption := 'FontColor';
  AdjustColorBox(DesignButton.MessageButton.Font.Color,14);
  ColorButtons[15].Caption := 'HoverColor';
  AdjustColorBox(DesignButton.MessageButton.HoverColor,15);
  ColorButtons[16].Caption := 'PressedCol';
  AdjustColorBox(DesignButton.MessageButton.PressedColor,16);

  ColorButtons[0].MessageButton.Visible    := true;
  ColorButtons[0].MessageButton.Caption    := 'G';
  ColorButtons[0].CaptionAlignment         := taLeftJustify;
  ColorButtons[0].CaptionHorMargin         := 4;
  ColorButtons[0].MessageButton.OnClick    := @SetColorGradient;
  ColorButtons[11].MessageButton.Visible   := true;
  ColorButtons[11].MessageButton.Caption   := 'G';
  ColorButtons[11].CaptionAlignment        := taLeftJustify;
  ColorButtons[11].CaptionHorMargin        := 4;
  ColorButtons[11].MessageButton.OnClick   := @SetColorGradient;

  ColorButtons[7].MessageButton.Visible    := true;
  ColorButtons[7].MessageButton.Caption    := #$CE#$B1;  //widechar($03B1);
  ColorButtons[7].CaptionAlignment         := taLeftJustify;
  ColorButtons[7].CaptionHorMargin         := 4;
  ColorButtons[7].MessageButton.Font.Height:= 18;
  ColorButtons[7].MessageButton.OnClick    := @SetAlphaBlendValue;
  ColorButtons[16].MessageButton.Visible   := true;
  ColorButtons[16].MessageButton.Caption   := #$CE#$B1;
  ColorButtons[16].CaptionAlignment        := taLeftJustify;
  ColorButtons[16].CaptionHorMargin        := 4;
  ColorButtons[16].MessageButton.Font.Height:= 18;
  ColorButtons[16].MessageButton.OnClick   := @SetAlphaBlendValue;
end;

procedure TStyleManagerComponent.ColorButtonsOnClick(Sender: TObject);
var ColorDialog : TColorDialog;
begin
 try
   ColorDialog    := TColorDialog.Create(nil);
   if ColorDialog.Execute then
   begin
    AdjustColorBox(ColorDialog.Color,(Sender as TMultiButton).Tag);
    case (Sender as TMultiButton).Tag of
     0: DesignButton.ColorStart        := ColorDialog.Color;
     1: DesignButton.ColorEnd          := ColorDialog.Color;
     2: DesignButton.BorderColor       := ColorDialog.Color;
     3: DesignButton.HoverStartColor   := ColorDialog.Color;
     4: DesignButton.HoverEndColor     := ColorDialog.Color;
     5: DesignButton.HoverFontColor    := ColorDialog.Color;
     6: DesignButton.Font.Color        := ColorDialog.Color;
     7: DesignButton.FocusColor        := ColorDialog.Color;
     8: DesignButton.PressedStartColor := ColorDialog.Color;
     9: DesignButton.PressedEndColor   := ColorDialog.Color;
    10: DesignButton.PressedFontColor  := ColorDialog.Color;
    11: DesignButton.MessageButton.ColorStart        := ColorDialog.Color;
    12: DesignButton.MessageButton.ColorEnd          := ColorDialog.Color;
    13: DesignButton.MessageButton.BorderColor       := ColorDialog.Color;
    14: DesignButton.MessageButton.Font.Color        := ColorDialog.Color;
    15: DesignButton.MessageButton.HoverColor        := ColorDialog.Color;
    16: DesignButton.MessageButton.PressedColor      := ColorDialog.Color;
    end;
   end;
 finally
   ColorDialog.Free;
 end;
end;

procedure TStyleManagerComponent.ColorBoxOnChange(Sender: TObject);
begin
 case (Sender as TColorBox).Tag of
     0: DesignButton.ColorStart        := (Sender as TColorBox).Selected;
     1: DesignButton.ColorEnd          := (Sender as TColorBox).Selected;
     2: DesignButton.BorderColor       := (Sender as TColorBox).Selected;
     3: DesignButton.HoverStartColor   := (Sender as TColorBox).Selected;
     4: DesignButton.HoverEndColor     := (Sender as TColorBox).Selected;
     5: DesignButton.HoverFontColor    := (Sender as TColorBox).Selected;
     6: DesignButton.Font.Color        := (Sender as TColorBox).Selected;
     7: DesignButton.FocusColor        := (Sender as TColorBox).Selected;
     8: DesignButton.PressedStartColor := (Sender as TColorBox).Selected;
     9: DesignButton.PressedEndColor   := (Sender as TColorBox).Selected;
    10: DesignButton.PressedFontColor  := (Sender as TColorBox).Selected;
    11: DesignButton.MessageButton.ColorStart        := (Sender as TColorBox).Selected;
    12: DesignButton.MessageButton.ColorEnd          := (Sender as TColorBox).Selected;
    13: DesignButton.MessageButton.BorderColor       := (Sender as TColorBox).Selected;
    14: DesignButton.MessageButton.Font.Color        := (Sender as TColorBox).Selected;
    15: DesignButton.MessageButton.HoverColor        := (Sender as TColorBox).Selected;
    16: DesignButton.MessageButton.PressedColor      := (Sender as TColorBox).Selected;
    end;
end;

procedure TStyleManagerComponent.SetColorGradient(Sender: TObject);
begin
 if Sender = ColorButtons[0] then
  begin
   look.Show;
   ColGradCombo.SetFocus;
  end else
  begin
   MsgButtonLook.Show;
   MsgColGradCombo.SetFocus;
  end;

end;

procedure TStyleManagerComponent.SetLeftTop(Sender: TObject);
begin
 case (Sender as TLabeledEdit).Tag of
  0: DesignButton.Left            := strtointdef((Sender as TLabeledEdit).Caption,0);
  1: DesignButton.Top             := strtointdef((Sender as TLabeledEdit).Caption,0);

 end;
end;

procedure TStyleManagerComponent.OffSet(Sender: TObject);
begin
 case (Sender as TCheckBox).Tag of
  0: OffSetWidth           := (Sender as TCheckBox).Checked;
  1: OffSetHeight          := (Sender as TCheckBox).Checked;
 end;
 if OffSetWidth then
  lEdits[0].Font.Color:= clDefault else lEdits[0].Font.Color:= clRed;
 if OffSetHeight then
  lEdits[1].Font.Color:= clDefault else lEdits[1].Font.Color:= clRed;
end;

procedure TStyleManagerComponent.SetAlphaBlendValue(Sender: TObject);
begin
 if Sender = ColorButtons[7] then
  begin
   look.Show;
   lEdits[4].SetFocus
  end else
  begin
   MsgButtonLook.Show;
   MsgEdits[3].SetFocus;
  end;
end;

procedure TStyleManagerComponent.VariousSettings;
var lv : integer;
begin
 Various                := TTabsheet.Create(Editor);
 Various.Parent         := Settings;
 Various.Caption        := 'Various';

  for lv:=0 to 2 do
  begin
   VariousCheckBox[lv]         := TCheckBox.Create(Various);
   VariousCheckBox[lv].Parent  := Various;
   VariousCheckBox[lv].Width   := 150;
   VariousCheckBox[lv].Height  :=  28;
   VariousCheckBox[lv].Tag     := lv;
   VariousCheckBox[lv].OnClick := @VariousCheckBoxOnClick;
  end;

   VariousCheckBox[0].Caption := 'AllowUp';
   VariousCheckBox[0].Checked := DesignButton.AllowsUp;
   VariousCheckBox[0].Left    := 10;
   VariousCheckBox[0].Top     := 10;

   VariousCheckBox[1].Caption := 'Down';
   VariousCheckBox[1].Checked := DesignButton.Down;
   VariousCheckBox[1].Left    := 10;
   VariousCheckBox[1].Top     := 40;

   VariousCheckBox[2].Caption := 'ShowMsgButtonInGroup';
   VariousCheckBox[2].Checked := DesignButton.ShowMsgButtonInGroup;
   VariousCheckBox[2].Left    := 10;
   VariousCheckBox[2].Top     := 70;

   GrIdxEdit         := TLabeledEdit.Create(Various);
   GrIdxEdit.Parent  := Various;
   GrIdxEdit.Width   :=  100;
   GrIdxEdit.Height  :=  18;
   GrIdxEdit.Alignment:= taRightJustify;
   GrIdxEdit.OnChange:= @GrIdxEditOnChange;
   GrIdxEdit.EditLabel.Caption := 'GroupIndex:';
   GrIdxEdit.Left    := 10;
   GrIdxEdit.Top     := 115;
   GrIdxEdit.Caption := inttostr(DesignButton.GroupIndex);
   if DesignButton.GroupIndex=0 then VariousCheckBox[2].Enabled:=false;
end;

procedure TStyleManagerComponent.VariousCheckBoxOnClick(Sender: TObject);
begin
 case (Sender as TCheckBox).Tag of
   0: DesignButton.AllowsUp                 := (Sender as TCheckBox).Checked;
   1: DesignButton.Down                     := (Sender as TCheckBox).Checked;
   2: DesignButton.ShowMsgButtonInGroup     := (Sender as TCheckBox).Checked;
  end;
 if DesignButton.ShowMsgButtonInGroup then MsgCheckBox[1].Checked:=true;
end;

procedure TStyleManagerComponent.GrIdxEditOnChange(Sender: TObject);
begin
 DesignButton.GroupIndex     := strtointdef((Sender as TLabeledEdit).Caption,0);
 if DesignButton.GroupIndex=0 then VariousCheckBox[2].Enabled:=false else VariousCheckBox[2].Enabled:=true;
end;

procedure TStyleManagerComponent.FontSettings;
var StaticText1   : TStaticText;
    StaticText2   : TStaticText;
    StaticText3   : TStaticText;
    StaticText4   : TStaticText;
    lv            : integer;
    StaticText5   : TStaticText;
    StaticText6   : TStaticText;
begin
 Fonts                := TTabsheet.Create(Editor);
 Fonts.Parent         := Settings;
 Fonts.Caption        := 'Fonts';

 StaticText1           := TStaticText.Create(Fonts);
 StaticText1.Parent    := Fonts;
 StaticText1.Caption   := 'MultiButton Settings:';
 StaticText1.SetBounds(10,5,300,25);

 StaticText2           := TStaticText.Create(Fonts);
 StaticText2.Parent    := Fonts;
 StaticText2.Caption   := 'MessageButton Settings:';
 StaticText2.SetBounds(400,5,300,25);

 StaticText3         := TStaticText.Create(Fonts);
 StaticText3.Parent  := Fonts;
 StaticText3.SetBounds(10,30,150,25);
 StaticText3.Caption := 'CaptionAlignment:';

 CapAligCombo        := TComboBox.Create(Fonts);
 CapAligCombo.Parent := Fonts;
 CapAligCombo.SetBounds(10,50,150,28);
 CapAligCombo.Items.Add('taLeftJustify');
 CapAligCombo.Items.Add('taRightJustify');
 CapAligCombo.Items.Add('taCenter');
 CapAligCombo.ItemIndex:= ord(DesignButton.CaptionAlignment);
 CapAligCombo.OnChange:= @CapAligOnChange;

 StaticText4         := TStaticText.Create(Fonts);
 StaticText4.Parent  := Fonts;
 StaticText4.SetBounds(200,30,150,25);
 StaticText4.Caption := 'CaptionLayout:';

 CapLayCombo        := TComboBox.Create(Fonts);
 CapLayCombo.Parent := Fonts;
 CapLayCombo.SetBounds(200,50,150,28);
 CapLayCombo.Items.Add('tlTop');
 CapLayCombo.Items.Add('tlCenter');
 CapLayCombo.Items.Add('tlBottom');
 CapLayCombo.ItemIndex:= ord(DesignButton.CaptionLayout);
 CapLayCombo.OnChange:= @CapLayOnChange;

 for lv:=0 to 3 do
  begin
   CapEdits[lv]         := TLabeledEdit.Create(Fonts);
   CapEdits[lv].Parent  := Fonts;
   CapEdits[lv].Width   :=  150;
   CapEdits[lv].Height  :=  18;
   CapEdits[lv].Tag     := lv;
   CapEdits[lv].Alignment:= taRightJustify;
   CapEdits[lv].OnChange:= @CapEditsOnChange;
  end;
 CapEdits[0].EditLabel.Caption := 'CaptionHorMargin:';
 CapEdits[0].Left    := 10;
 CapEdits[0].Top     := 100;
 CapEdits[0].Caption := inttostr(DesignButton.CaptionHorMargin);
 if DesignButton.CaptionAlignment <> taLeftJustify then CapEdits[0].Enabled:= false;

 CapEdits[1].EditLabel.Caption := 'CaptionVerMargin:';
 CapEdits[1].Left    := 200;
 CapEdits[1].Top     := 100;
 CapEdits[1].Caption := inttostr(DesignButton.CaptionVerMargin);
 if DesignButton.CaptionLayout <> tlTop then CapEdits[1].Enabled:= false;

 for lv:=0 to 1 do
  begin
   FontDialogB[lv]         := TMultiButton.Create(Fonts);
   FontDialogB[lv].Parent  := Fonts;
   FontDialogB[lv].Width   := 150;
   FontDialogB[lv].Height  :=  28;
   FontDialogB[lv].FocusFrameWidth:= 2;
   FontDialogB[lv].Style   := MultiButton.TMButtonStyle(mbsRect);
   FontDialogB[lv].Tag     := lv;
   FontDialogB[lv].OnClick := @FontDialogOnClick;
  end;
 FontDialogB[0].Caption     :='Font';
 FontDialogB[0].Left        := 10;
 FontDialogB[0].Top         := 140;

 WordBCheckBox         := TCheckBox.Create(Fonts);
 WordBCheckBox.Parent  := Fonts;
 WordBCheckBox.Width   := 150;
 WordBCheckBox.Height  :=  28;
 WordBCheckBox.OnClick := @WordBOnClick;
 WordBCheckBox.Caption := 'CaptionWordBreak';
 WordBCheckBox.Checked := DesignButton.CaptionWordbreak;
 WordBCheckBox.Left    := 200;
 WordBCheckBox.Top     := 140;


 StaticText5         := TStaticText.Create(Fonts);
 StaticText5.Parent  := Fonts;
 StaticText5.SetBounds(400,30,150,25);
 StaticText5.Caption := 'CaptionAlignment:';

 MsgCapAligCombo        := TComboBox.Create(Fonts);
 MsgCapAligCombo.Parent := Fonts;
 MsgCapAligCombo.SetBounds(400,50,150,28);
 MsgCapAligCombo.Items.Add('taLeftJustify');
 MsgCapAligCombo.Items.Add('taRightJustify');
 MsgCapAligCombo.Items.Add('taCenter');
 MsgCapAligCombo.ItemIndex:= ord(DesignButton.MessageButton.CaptionAlignment);
 MsgCapAligCombo.OnChange:= @MsgCapAligOnChange;

 StaticText6         := TStaticText.Create(Fonts);
 StaticText6.Parent  := Fonts;
 StaticText6.SetBounds(590,30,150,25);
 StaticText6.Caption := 'CaptionLayout:';

 MsgCapLayCombo        := TComboBox.Create(Fonts);
 MsgCapLayCombo.Parent := Fonts;
 MsgCapLayCombo.SetBounds(590,50,150,28);
 MsgCapLayCombo.Items.Add('tlTop');
 MsgCapLayCombo.Items.Add('tlCenter');
 MsgCapLayCombo.Items.Add('tlBottom');
 MsgCapLayCombo.ItemIndex:= ord(DesignButton.MessageButton.CaptionLayout);
 MsgCapLayCombo.OnChange:= @MsgCapLayOnChange;

 CapEdits[2].EditLabel.Caption := 'CaptionHorMargin:';
 CapEdits[2].Left    := 400;
 CapEdits[2].Top     := 100;
 CapEdits[2].Caption := inttostr(DesignButton.MessageButton.CaptionHorMargin);
 if DesignButton.MessageButton.CaptionAlignment <> taLeftJustify then CapEdits[2].Enabled:= false;

 CapEdits[3].EditLabel.Caption := 'CaptionVerMargin:';
 CapEdits[3].Left    := 590;
 CapEdits[3].Top     := 100;
 CapEdits[3].Caption := inttostr(DesignButton.MessageButton.CaptionVerMargin);
 if DesignButton.MessageButton.CaptionLayout <> tlTop then CapEdits[3].Enabled:= false;

 FontDialogB[1].Caption     :='Font';
 FontDialogB[1].Left        := 400;
 FontDialogB[1].Top         := 140;
end;

procedure TStyleManagerComponent.CapAligOnChange(Sender: TObject);
begin
 case (Sender as TComboBox).ItemIndex of
  0 : DesignButton.CaptionAlignment := taLeftJustify;
  1 : DesignButton.CaptionAlignment := taRightJustify;
  2 : DesignButton.CaptionAlignment := taCenter;
 end;
 if DesignButton.CaptionAlignment <> taLeftJustify then CapEdits[0].Enabled:= false else CapEdits[0].Enabled:=true;
end;

procedure TStyleManagerComponent.CapLayOnChange(Sender: TObject);
begin
 case (Sender as TComboBox).ItemIndex of
  0 : DesignButton.CaptionLayout := tlTop;
  1 : DesignButton.CaptionLayout := tlCenter;
  2 : DesignButton.CaptionLayout := tlBottom;
 end;
 if DesignButton.CaptionLayout <> tlTop then CapEdits[1].Enabled:= false else CapEdits[1].Enabled := true;
end;

procedure TStyleManagerComponent.CapEditsOnChange(Sender: TObject);
begin
  case (Sender as TLabeledEdit).Tag of
  0: DesignButton.CaptionHorMargin      := strtointdef((Sender as TLabeledEdit).Caption,0);
  1: DesignButton.CaptionVerMargin      := strtointdef((Sender as TLabeledEdit).Caption,0);

 end;
end;

procedure TStyleManagerComponent.FontDialogOnClick(Sender: TObject);
var FontDialog : TFontDialog;

begin
 try
  FontDialog := TFontDialog.Create(nil);
  if (Sender as TMultiButton).Tag = 0 then
   begin
    FontDialog.Font := DesignButton.Font;
    if FontDialog.Execute then DesignButton.Font := FontDialog.Font;
   end;
  if (Sender as TMultiButton).Tag = 1 then
   begin
    FontDialog.Font := DesignButton.MessageButton.Font;
    if FontDialog.Execute then DesignButton.MessageButton.Font := FontDialog.Font;
   end;
 finally
  FontDialog.Free;
 end;
end;

procedure TStyleManagerComponent.WordBOnClick(Sender: TObject);
begin
 DesignButton.CaptionWordbreak    := (Sender as TCheckBox).Checked;
end;

procedure TStyleManagerComponent.MsgCapAligOnChange(Sender: TObject);
begin
 case (Sender as TComboBox).ItemIndex of
  0 : DesignButton.MessageButton.CaptionAlignment := taLeftJustify;
  1 : DesignButton.MessageButton.CaptionAlignment := taRightJustify;
  2 : DesignButton.MessageButton.CaptionAlignment := taCenter;
 end;
 if DesignButton.MessageButton.CaptionAlignment <> taLeftJustify then CapEdits[2].Enabled:= false else CapEdits[2].Enabled:=true;
end;

procedure TStyleManagerComponent.MsgCapLayOnChange(Sender: TObject);
begin
 case (Sender as TComboBox).ItemIndex of
  0 : DesignButton.MessageButton.CaptionLayout := tlTop;
  1 : DesignButton.MessageButton.CaptionLayout := tlCenter;
  2 : DesignButton.MessageButton.CaptionLayout := tlBottom;
 end;
 if DesignButton.MessageButton.CaptionLayout <> tlTop then CapEdits[3].Enabled:= false else CapEdits[3].Enabled := true;
end;

procedure TStyleManagerComponent.OK_AbortButtonOnClick(Sender: TObject);
begin
 if (Sender as TMultiButton).Tag = 102 then
  begin
   Editor.Close;
   exit;
  end;

 (StyleComp as TMultiButtonStyleManager).OffSetWidth       := OffSetWidth;
 (StyleComp as TMultiButtonStyleManager).OffSetHeight      := OffSetHeight;

 (StyleComp as TMultiButtonStyleManager).Style             := MultiButtonStyleManager.TMButtonStyle(DesignButton.Style);
 if OffSetWidth then
 (StyleComp as TMultiButtonStyleManager).Width             := DesignButton.Width;
 if OffSetHeight then
 (StyleComp as TMultiButtonStyleManager).Height            := DesignButton.Height;
 (StyleComp as TMultiButtonStyleManager).RndRctRadius      := DesignButton.RndRctRadius;
 (StyleComp as TMultiButtonStyleManager).FocusedOn         := DesignButton.FocusedOn;
 (StyleComp as TMultiButtonStyleManager).FocusFrameWidth   := DesignButton.FocusFrameWidth;
 (StyleComp as TMultiButtonStyleManager).FocusAlphaBValue  := DesignButton.FocusAlphaBValue;
 (StyleComp as TMultiButtonStyleManager).ShowBorder        := DesignButton.ShowBorder;
 (StyleComp as TMultiButtonStyleManager).HoverOn           := DesignButton.HoverOn;
 (StyleComp as TMultiButtonStyleManager).BorderWidth       := DesignButton.BorderWidth;
 (StyleComp as TMultiButtonStyleManager).ColorGradient     := MultiButtonStyleManager.TGradientCourse(DesignButton.ColorGradient);

 (StyleComp as TMultiButtonStyleManager).MessageButtonVisible  := DesignButton.MessageButton.Visible;
 (StyleComp as TMultiButtonStyleManager).MessageButtonStyle    := MultiButtonStyleManager.TMButtonStyle(DesignButton.MessageButton.Style);
 (StyleComp as TMultiButtonStyleManager).MessageButtonWidth    := DesignButton.MessageButton.Width;
 (StyleComp as TMultiButtonStyleManager).MessageButtonHeight   := DesignButton.MessageButton.Height;
 (StyleComp as TMultiButtonStyleManager).MessageButtonAlignment:= MultiButtonStyleManager.TMBAlignment(DesignButton.MessageButton.Alignment);
 (StyleComp as TMultiButtonStyleManager).MessageButtonPositionFactor:= DesignButton.MessageButton.PositionFactor;
 (StyleComp as TMultiButtonStyleManager).MessageButtonCalculateAlthoughInvisible:= DesignButton.MessageButton.CalculateAlthoughInvisible;
 (StyleComp as TMultiButtonStyleManager).MessageButtonHoverOn  := DesignButton.MessageButton.HoverOn;
 (StyleComp as TMultiButtonStyleManager).MessageButtonShowPressed:= DesignButton.MessageButton.ShowPressed;
 (StyleComp as TMultiButtonStyleManager).MessageButtonShowBorder:= DesignButton.MessageButton.ShowBorder;
 (StyleComp as TMultiButtonStyleManager).MessageButtonPresdColBlendVal:= DesignButton.MessageButton.PresdColBlendVal;
 (StyleComp as TMultiButtonStyleManager).MessageButtonBorderWidth:= DesignButton.MessageButton.BorderWidth;
 (StyleComp as TMultiButtonStyleManager).MessageButtonColorGradient:= MultiButtonStyleManager.TGradientCourse(DesignButton.MessageButton.ColorGradient);

 (StyleComp as TMultiButtonStyleManager).ColorStart        := DesignButton.ColorStart;
 (StyleComp as TMultiButtonStyleManager).ColorEnd          := DesignButton.ColorEnd;
 (StyleComp as TMultiButtonStyleManager).BorderColor       := DesignButton.BorderColor;
 (StyleComp as TMultiButtonStyleManager).HoverStartColor   := DesignButton.HoverStartColor;
 (StyleComp as TMultiButtonStyleManager).HoverEndColor     := DesignButton.HoverEndColor;
 (StyleComp as TMultiButtonStyleManager).HoverFontColor    := DesignButton.HoverFontColor;
 (StyleComp as TMultiButtonStyleManager).Font.Assign(DesignButton.Font);
 (StyleComp as TMultiButtonStyleManager).FocusColor        := DesignButton.FocusColor;
 (StyleComp as TMultiButtonStyleManager).PressedStartColor := DesignButton.PressedStartColor;
 (StyleComp as TMultiButtonStyleManager).PressedEndColor   := DesignButton.PressedEndColor;
 (StyleComp as TMultiButtonStyleManager).PressedFontColor  := DesignButton.PressedFontColor;
 (StyleComp as TMultiButtonStyleManager).MessageButtonColorStart          := DesignButton.MessageButton.ColorStart;
 (StyleComp as TMultiButtonStyleManager).MessageButtonColorEnd            := DesignButton.MessageButton.ColorEnd;
 (StyleComp as TMultiButtonStyleManager).MessageButtonBorderColor         := DesignButton.MessageButton.BorderColor;
 (StyleComp as TMultiButtonStyleManager).MessageButtonFont.Assign(DesignButton.MessageButton.Font);
 (StyleComp as TMultiButtonStyleManager).MessageButtonHoverColor          := DesignButton.MessageButton.HoverColor;
 (StyleComp as TMultiButtonStyleManager).MessageButtonPressedColor        := DesignButton.MessageButton.PressedColor;

 (StyleComp as TMultiButtonStyleManager).AllowsUp             := DesignButton.AllowsUp;
 (StyleComp as TMultiButtonStyleManager).Down                 := DesignButton.Down;
 (StyleComp as TMultiButtonStyleManager).ShowMsgButtonInGroup := DesignButton.ShowMsgButtonInGroup;
 (StyleComp as TMultiButtonStyleManager).GroupIndex           := DesignButton.GroupIndex;

 (StyleComp as TMultiButtonStyleManager).CaptionAlignment     := DesignButton.CaptionAlignment;
 (StyleComp as TMultiButtonStyleManager).CaptionLayout        := DesignButton.CaptionLayout;
 (StyleComp as TMultiButtonStyleManager).CaptionHorMargin     := DesignButton.CaptionHorMargin;
 (StyleComp as TMultiButtonStyleManager).CaptionVerMargin     := DesignButton.CaptionVerMargin;
 (StyleComp as TMultiButtonStyleManager).CaptionWordbreak     := DesignButton.CaptionWordbreak;

 (StyleComp as TMultiButtonStyleManager).MessageButtonCaptionAlignment     := DesignButton.MessageButton.CaptionAlignment;
 (StyleComp as TMultiButtonStyleManager).MessageButtonCaptionLayout        := DesignButton.MessageButton.CaptionLayout;
 (StyleComp as TMultiButtonStyleManager).MessageButtonCaptionHorMargin     := DesignButton.MessageButton.CaptionHorMargin;
 (StyleComp as TMultiButtonStyleManager).MessageButtonCaptionVerMargin     := DesignButton.MessageButton.CaptionVerMargin;



 (StyleComp as TMultiButtonStyleManager).Modified;
 Editor.Close;
end;









